<?php

/**
 * @package plugin NicePanel
 * @copyright (C) 2010-2011 RicheyWeb - www.richeyweb.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * NicePanel Copyright (c) 2010 Michael Richey.
 * NicePanel is licensed under the http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
require_once('mobiledetect.php');

/**
 * NicePanel system plugin
 */
class plgSystemNicePanel extends JPlugin {

    public $_run;
    public $_positions;
    public $_options;
    public $_output;
    /**
     * Constructor
     *
     * @access	protected
     * @param	object	$subject The object to observe
     * @param 	array   $config  An array that holds the plugin configuration
     * @since	1.0
     */
    function plgSystemNicePanel(&$subject, $config) {
        $this->_run = true;
        $this->_positions = array();
        $this->_options = array('positions' => array());
        $this->_output='';
        parent::__construct($subject, $config);
    }

    function onAfterRoute() {
        $app = JFactory::getApplication();
        $doc = JFactory::getDocument();
        if (
                $app->isAdmin() || 
                $doc->getType() != 'html' || 
                $app->input->get('tmpl','','cmd') == 'component' || 
                ($app->getCfg('offline') && JFactory::getUser()->guest)
            ) {
            $this->_run = false;
            return; // not the right place to run this plugin
        }      
        if(@$hidemobile = (int)$this->params->get('hidemobile',0)) {
            $detect = new Mobile_Detect();
            if($detect->isMobile() ) {
                switch($hidemobile) {
                    case 1:
                        $this->_run = false;
                        break;
                    case 2:
                        if(!$detect->isTablet()) $this->_run = false;
                        break;
                    case 3:
                        if($detect->isTablet()) $this->_run = false;
                        break;
                }
                if($this->_run === false) return;
            }
        }      
        if(@$hidetemplate = $this->params->get('hidetemplate',false)) {
            if(count($hidetemplate)) {
                if(in_array($app->getTemplate(true)->id,$hidetemplate)) {
                    $this->_run = false;
                    return;
                }
            }
        }
        foreach(array('top','bottom') as $p) {
            $a = array();
            $a['name']=$this->params->get($p.'positions','none');
            if($a['name']=='none') continue;
            $a['location']=$p;
            $a['position']=$this->params->get($p.'positioning','absolute');
            $a['align']=$this->params->get($p.'align','left');
            $this->_positions[$p]=$a;
        }
        if (!count($this->_positions)) {
            $this->_run = false;
            return; // no positions saved in the plugin
        }
        include_once(JPATH_ROOT . '/plugins/system/nicepanel/html/modules.php');
        // some devs forget to load the component model before they use it
        jimport('joomla.application.component.model');
        $renderer = $doc->loadRenderer('modules');
        foreach ($this->_positions as $l=>$p) {
            if (count(JModuleHelper::getModules($p['name']))) {
                $attribs = array('style'=>'NicePanel','name'=>$p['name'],'location'=>$l,'position'=>$p['position'],'align'=>$p['align']);
                $this->_output.=$renderer->render($p['name'], $attribs, null);
                $this->_options['positions'][$l] = $p['name'];
            }
        }
        JHtml::_('behavior.framework', true);
        $doc->addScript(JURI::root(true) . '/media/plg_system_nicepanel/nicepanel.js');
        $doc->addStyleSheet(JURI::root(true) . '/media/plg_system_nicepanel/nicepanel.css');
        if($this->params->get('usestyle',1)) $doc->addStyleDeclaration("\n".$this->params->get('style','')."\n");
        $doc->addScriptDeclaration("\nwindow.plg_system_nicepanel_options = " . json_encode($this->_options) . ";\n");
    }

    function onAfterRender() {  
        if(!$this->_run) return;      
        $app = JFactory::getApplication();
        if($app->input->get('tmpl') == 'component') return;
        if(JFactory::getDocument()->getType() != 'html') return;
        $body = JResponse::getBody();
        $body = str_replace('</body>', $this->_output . "\n</body>",$body);
        JResponse::setBody($body);
    }
}
